<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateEventsTable extends Migration {
  /**
   * Run the migrations.
   *
   * @return void
   */
  public function up() {
    Schema::create('events', function (Blueprint $table) {
      $table->uuid('uuid')->primary();
      $table->string('command');
      $table->string('name')->nullable();
      $table->text('value')->nullable();
      $table->uuid('version')->nullable();
      $table->uuid('version_new')->nullable();
      $table->uuid('model_uuid')->nullable();
      $table->uuid('user_uuid')->nullable();
      $table->string('user_agent')->nullable();
      $table->string('app_version')->nullable();
      $table->string('device_model_number')->nullable();
      $table->string('device_os_version')->nullable();
      $table->timestamp('occurred_at');
      $table->timestamps();
    });
  }

  /**
   * Reverse the migrations.
   *
   * @return void
   */
  public function down() {
    Schema::dropIfExists('events');
  }
}
