<?php

namespace Myriad\EventDrivenService;

use Illuminate\Support\ServiceProvider;

class EventDrivenServiceProvider extends ServiceProvider {
  /**
   * Bootstrap services.
   *
   * @return void
   */
  public function boot() {
    $this->publishes([__DIR__ . '/../database/' => database_path('migrations')], 'migrations');
    $this->publishes([__DIR__ . '/../config/events.php' => config_path('events.php')], 'config');

    $this->loadTranslationsFrom(__DIR__ . '/../resources/lang', 'event-driven-service');

    $this->publishes([__DIR__ . '/../resources/lang' => resource_path('lang/vendor/event-driven-service')], 'translations');
  }

  /**
   * Register services.
   *
   * @return void
   */
  public function register() {
    $this->app->make('Myriad\EventDrivenService\Http\Controllers\Api\EventsController');
  }
}
