<?php

namespace Myriad\EventDrivenService\Http\Controllers\Api;

use Illuminate\Http\Request;
use Illuminate\Http\Resources\Json\JsonResource;
use Illuminate\Routing\Controller;
use Myriad\EventDrivenService\Http\Requests\PaginationRequest;
use Myriad\EventDrivenService\Services\EventService;

class EventsController extends Controller {

  public function getEvents($uri, PaginationRequest $request, EventService $eventService) {
    $new = $eventService->getNew($uri, $request->last_update, $request->page_size);
    $new['meta']['last_sync'] = floor(LARAVEL_START);
    return JsonResource::collection($new['data'])->additional(['meta' => $new['meta']]);
  }

  public function store(Request $request, EventService $eventService) {
    list($errors) = $eventService->handlePost($request, false);
    return response()->json($errors, 201);
  }

  public function storeWithUpdates(Request $request, EventService $eventService) {
    list($errors, $updates) = $eventService->handlePost($request, true);
    return response()->json([
      'errors' => $errors,
      'updates' => $updates,
    ], 201);
  }

  public function bulkEvents(Request $request, EventService $eventService) {
    return $eventService->handleBulkEvents($request);
  }
}
