<?php

namespace Myriad\EventDrivenService\Http\Utilities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\ModelNotFoundException;

class EventHelper {

  const OCCURRED_AT_FORMAT = 'Y-m-d\TH:i:s.uP';

  public static function getModelByUri($uri) {
    return self::getModel('uri', $uri);
  }

  public static function getModelByType($modelType) {
    return self::getModel('command', $modelType);
  }

  public static function getCommandForModel(Model $model) {
    foreach (config('events.models') as $current) {
      if ($model instanceof $current['model']) {
        return $current['command'];
      }
    }
    throw new ModelNotFoundException('Invalid model provided.');
  }

  private static function getModel($function, $value) {
    foreach (config('events.models') as $eventModel) {
      if ($eventModel[$function] == $value) {
        return app($eventModel['model']);
      }
    }
    throw new ModelNotFoundException('Invalid model provided.');
  }
}