<?php

namespace Myriad\EventDrivenService\Models;

use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Model;

class EventHadAccess extends Model {

  protected $table = 'event_had_access';
  protected $primaryKey = ['model_uuid', 'user_uuid'];
  public $incrementing = false;

  protected $fillable = [
    'model_uuid',
    'user_uuid',
    'model',
    'last_requested_at',
    'lost_at',
  ];

  public $timestamps = false;

  protected function setKeysForSaveQuery(Builder $query) {
    $keys = $this->getKeyName();
    if (!is_array($keys)) {
      return parent::setKeysForSaveQuery($query);
    }

    foreach ($keys as $keyName) {
      $query->where($keyName, '=', $this[$keyName]);
    }

    return $query;
  }
}
