<?php

namespace Myriad\EventDrivenService\Models;

use Ramsey\Uuid\Uuid;
use Illuminate\Support\Facades\Auth;

class FailedEvent extends UUIDModel {

  protected static function boot() {
    parent::boot();
    self::creating(function ($model) {
      $model->uuid = Uuid::uuid4();
      $model->user_uuid = Auth::id();
    });
  }

  protected $fillable = [
    'command',
    'model_uuid',
    'name',
    'version',
    'version_new',
    'value',
    'reason',
    'occurred_at',
    'app_version',
    'user_agent',
    'device_model_number',
    'device_os_version',
    'platform',
    'release_version',
  ];
}
