<?php


namespace Myriad\EventDrivenService\Traits;

use Illuminate\Validation\ValidationException;

trait EventExceptionHandler {

  use Logger;

  protected function handleValidationError($event, ValidationException $e) {
    $message = "";
    foreach ($e->errors() as $error) {
      foreach ($error as $errorMessage) {
        $message .= $errorMessage . " ";
      }
    }
    return $this->formatError($event, $message);
  }

  protected function formatError($attributes, $errorMessage, $shouldLog = false) {
    $error = [
      'request' => $attributes,
      'error' => $errorMessage
    ];
    if ($shouldLog) {
      $this->logError($error);
    }
    return $error;
  }
}
